Index: /pjproject/trunk/pjlib-util/build/Makefile
===================================================================
--- /pjproject/trunk/pjlib-util/build/Makefile	(revision 1487)
+++ /pjproject/trunk/pjlib-util/build/Makefile	(revision 1488)
@@ -28,5 +28,5 @@
 export PJLIB_UTIL_SRCDIR = ../src/pjlib-util
 export PJLIB_UTIL_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
-		crc32.o errno.o dns.o dns_dump.o getopt.o \
+		base64.o crc32.o errno.o dns.o dns_dump.o getopt.o \
 		hmac_md5.o hmac_sha1.o md5.o resolver.o \
 		scanner.o sha1.o srv_resolver.o string.o stun_simple.o \
Index: /pjproject/trunk/pjlib-util/build/pjlib_util.dsp
===================================================================
--- /pjproject/trunk/pjlib-util/build/pjlib_util.dsp	(revision 1487)
+++ /pjproject/trunk/pjlib-util/build/pjlib_util.dsp	(revision 1488)
@@ -41,4 +41,5 @@
 # PROP Intermediate_Dir "./output/pjlib-util-i386-win32-vc6-release"
 # PROP Target_Dir ""
+F90=df.exe
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
 # ADD CPP /nologo /MD /W4 /GX /Zi /O2 /Ob2 /I "../include" /I "../../pjlib/include" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /c
@@ -65,4 +66,5 @@
 # PROP Intermediate_Dir "./output/pjlib-util-i386-win32-vc6-debug"
 # PROP Target_Dir ""
+F90=df.exe
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
 # ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /GZ /c
@@ -88,4 +90,8 @@
 # Begin Source File
 
+SOURCE="..\src\pjlib-util\base64.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\pjlib-util\crc32.c"
 # End Source File
@@ -168,4 +174,8 @@
 
 # PROP Default_Filter "h;hpp;hxx;hm;inl"
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\base64.h"
+# End Source File
 # Begin Source File
 
Index: /pjproject/trunk/pjlib-util/include/pjlib-util/base64.h
===================================================================
--- /pjproject/trunk/pjlib-util/include/pjlib-util/base64.h	(revision 1488)
+++ /pjproject/trunk/pjlib-util/include/pjlib-util/base64.h	(revision 1488)
@@ -0,0 +1,91 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJLIB_UTIL_BASE64_H__
+#define __PJLIB_UTIL_BASE64_H__
+
+/**
+ * @file base64.h
+ * @brief Base64 encoding and decoding
+ */
+
+#include <pjlib-util/types.h>
+
+PJ_BEGIN_DECL
+
+/**
+ * @defgroup PJLIB_UTIL_BASE64 Base64 Encoding/Decoding
+ * @ingroup PJLIB_UTIL_ENCRYPTION
+ * @{
+ * This module implements base64 encoding and decoding.
+ */
+
+/**
+ * Helper macro to calculate the approximate length required for base256 to
+ * base64 conversion.
+ */
+#define PJ_BASE256_TO_BASE64_LEN(len)	(len * 4 / 3 + 3)
+
+/**
+ * Helper macro to calculate the approximage length required for base64 to
+ * base256 conversion.
+ */
+#define PJ_BASE64_TO_BASE256_LEN(len)	(len * 3 / 4)
+
+
+/**
+ * Encode a buffer into base64 encoding.
+ *
+ * @param input	    The input buffer.
+ * @param in_len    Size of the input buffer.
+ * @param output    Output buffer. Caller must allocate this buffer with
+ *		    the appropriate size.
+ * @param out_len   On entry, it specifies the length of the output buffer. 
+ *		    Upon return, this will be filled with the actual
+ *		    length of the output buffer.
+ *
+ * @return	    PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pj_base64_encode(const pj_uint8_t *input, int in_len,
+				     char *output, int *out_len);
+
+
+/**
+ * Decode base64 string.
+ *
+ * @param input	    Input string.
+ * @param out	    Buffer to store the output. Caller must allocate
+ *		    this buffer with the appropriate size.
+ * @param out_len   On entry, it specifies the length of the output buffer. 
+ *		    Upon return, this will be filled with the actual
+ *		    length of the output.
+ */
+PJ_DECL(pj_status_t) pj_base64_decode(const pj_str_t *input, 
+				      pj_uint8_t *out, long *out_len);
+
+
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+
+#endif	/* __PJLIB_UTIL_BASE64_H__ */
+
Index: /pjproject/trunk/pjlib-util/src/pjlib-util-test/encryption.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util-test/encryption.c	(revision 1487)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util-test/encryption.c	(revision 1488)
@@ -466,7 +466,110 @@
 
 
+/*
+ * Base64 test vectors (RFC 4648)
+ */
+static struct base64_test_vec
+{
+    const char *base256;
+    const char *base64;
+} base64_test_vec[] = 
+{
+    {
+	"",
+	""
+    },
+    {
+	"f",
+	"Zg=="
+    },
+    {
+	"fo",
+	"Zm8="
+    },
+    {
+	"foo",
+	"Zm9v"
+    },
+    {
+	"foob",
+	"Zm9vYg=="
+    },
+    {
+	"fooba",
+	"Zm9vYmE=",
+    },
+    {
+	"foobar",
+	"Zm9vYmFy"
+    },
+    {
+	"\x14\xfb\x9c\x03\xd9\x7e",
+	"FPucA9l+"
+    },
+    {
+	"\x14\xfb\x9c\x03\xd9",
+	"FPucA9k="
+    },
+    {
+	"\x14\xfb\x9c\x03",
+	"FPucAw=="
+    }
+};
+
+
+static int base64_test(void)
+{
+    unsigned i;
+    char output[80];
+    pj_status_t rc;
+
+    PJ_LOG(3, (THIS_FILE, "  base64 test.."));
+
+    for (i=0; i<PJ_ARRAY_SIZE(base64_test_vec); ++i) {
+	/* Encode test */
+	pj_str_t input;
+	int out_len = sizeof(output);
+
+	rc = pj_base64_encode(base64_test_vec[i].base256, 
+			      strlen(base64_test_vec[i].base256),
+			      output, &out_len);
+	if (rc != PJ_SUCCESS)
+	    return -90;
+
+	if (out_len != strlen(base64_test_vec[i].base64))
+	    return -91;
+
+	output[out_len] = '\0';
+	if (strcmp(output, base64_test_vec[i].base64) != 0)
+	    return -92;
+
+	/* Decode test */
+	out_len = sizeof(output);
+	input.ptr = base64_test_vec[i].base64;
+	input.slen = strlen(base64_test_vec[i].base64);
+	rc = pj_base64_decode(&input, (pj_uint8_t*)output, &out_len);
+	if (rc != PJ_SUCCESS)
+	    return -95;
+
+	if (out_len != strlen(base64_test_vec[i].base256))
+	    return -96;
+
+	output[out_len] = '\0';
+
+	if (strcmp(output, base64_test_vec[i].base256) != 0)
+	    return -97;
+    }
+
+    return 0;
+}
+
+
 int encryption_test()
 {
     int rc;
+
+    rc = base64_test();
+    if (rc != 0)
+	return rc;
 
     rc = sha1_test1();
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/base64.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/base64.c	(revision 1488)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/base64.c	(revision 1488)
@@ -0,0 +1,181 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pjlib-util/base64.h>
+#include <pj/assert.h>
+#include <pj/errno.h>
+
+#define INV	    -1
+#define PADDING	    '='
+
+const char base64_char[] = {
+    'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',
+    'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
+    'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd',
+    'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
+    'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x',
+    'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7',
+    '8', '9', '+', '/' 
+};
+
+static int base256_char(char c)
+{
+    if (c >= 'A' && c <= 'Z')
+	return (c - 'A');
+    else if (c >= 'a' && c <= 'z')
+	return (c - 'a' + 26);
+    else if (c >= '0' && c <= '9')
+	return (c - '0' + 52);
+    else if (c == '+')
+	return (62);
+    else if (c == '/')
+	return (63);
+    else {
+	pj_assert(!"Should not happen as '=' should have been filtered");
+	return INV;
+    }
+}
+
+
+static void base256to64(pj_uint8_t c1, pj_uint8_t c2, pj_uint8_t c3, 
+			int padding, char *output)
+{
+    *output++ = base64_char[c1>>2];
+    *output++ = base64_char[((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4)];
+    switch (padding) {
+    case 0:
+	*output++ = base64_char[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)];
+	*output = base64_char[c3 & 0x3F];
+	break;
+    case 1:
+	*output++ = base64_char[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)];
+	*output = PADDING;
+	break;
+    case 2:
+    default:
+	*output++ = PADDING;
+	*output = PADDING;
+	break;
+    }
+}
+
+
+PJ_DEF(pj_status_t) pj_base64_encode(const pj_uint8_t *input, int in_len,
+				     char *output, int *out_len)
+{
+    const pj_uint8_t *pi = input;
+    pj_uint8_t c1, c2, c3;
+    int i = 0;
+    char *po = output;
+
+    PJ_ASSERT_RETURN(input && output && out_len, PJ_EINVAL);
+    PJ_ASSERT_RETURN(*out_len >= PJ_BASE256_TO_BASE64_LEN(in_len), 
+		     PJ_ETOOSMALL);
+
+    while (i < in_len) {
+	c1 = *pi++;
+	++i;
+
+	if (i == in_len) {
+	    base256to64(c1, 0, 0, 2, po);
+	    po += 4;
+	    break;
+	} else {
+	    c2 = *pi++;
+	    ++i;
+
+	    if (i == in_len) {
+		base256to64(c1, c2, 0, 1, po);
+		po += 4;
+		break;
+	    } else {
+		c3 = *pi++;
+		++i;
+		base256to64(c1, c2, c3, 0, po);
+	    }
+	}
+
+	po += 4;
+    }
+
+    *out_len = po - output;
+    return PJ_SUCCESS;
+}
+
+
+PJ_DEF(pj_status_t) pj_base64_decode(const pj_str_t *input, 
+				     pj_uint8_t *out, long *out_len)
+{
+    const char *buf = input->ptr;
+    int len = input->slen;
+    int i, j;
+    int c1, c2, c3, c4;
+
+    PJ_ASSERT_RETURN(input && out && out_len, PJ_EINVAL);
+
+    while (buf[len-1] == '=' && len)
+	--len;
+
+    PJ_ASSERT_RETURN(*out_len >= PJ_BASE64_TO_BASE256_LEN(len), 
+		     PJ_ETOOSMALL);
+
+    for (i=0, j=0; i+3 < len; i+=4) {
+	c1 = base256_char(buf[i]);
+	c2 = base256_char(buf[i+1]);
+	c3 = base256_char(buf[i+2]);
+	c4 = base256_char(buf[i+3]);
+
+	out[j++] = (pj_uint8_t)((c1<<2) | ((c2 & 0x30)>>4));
+	out[j++] = (pj_uint8_t)(((c2 & 0x0F)<<4) | ((c3 & 0x3C)>>2));
+	out[j++] = (pj_uint8_t)(((c3 & 0x03)<<6) | (c4 & 0x3F));
+    }
+
+    if (i < len) {
+	c1 = base256_char(buf[i]);
+
+	if (i+1 < len)
+	    c2 = base256_char(buf[i+1]);
+	else 
+	    c2 = (INV);
+
+	if (i+2 < len)
+	    c3 = base256_char(buf[i+2]);
+	else
+	    c3 = (INV);
+
+	c4 = (INV);
+
+	if (c2 != INV) {
+	    out[j++] = (pj_uint8_t)((c1<<2) | ((c2 & 0x30)>>4));
+	    if (c3 != INV) {
+		out[j++] = (pj_uint8_t)(((c2 & 0x0F)<<4) | ((c3 & 0x3C)>>2));
+		if (c4 != INV) {
+		    out[j++] = (pj_uint8_t)(((c3 & 0x03)<<6) | (c4 & 0x3F));
+		}
+	    }
+	}
+	
+    }
+
+    pj_assert(j < *out_len);
+    *out_len = j;
+
+    return PJ_SUCCESS;
+}
+
+
Index: /pjproject/trunk/pjproject-vs8.sln
===================================================================
--- /pjproject/trunk/pjproject-vs8.sln	(revision 1487)
+++ /pjproject/trunk/pjproject-vs8.sln	(revision 1488)
@@ -29,4 +29,6 @@
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsua", "pjsip-apps\build\pjsua.vcproj", "{8310649E-A25E-4AF0-91E8-9E3CC659BB89}"
 	ProjectSection(ProjectDependencies) = postProject
+		{2BB84911-C1B4-4747-B93D-36AA82CC5031} = {2BB84911-C1B4-4747-B93D-36AA82CC5031}
+		{4BF51C21-5A30-423B-82FE-1ED410E5769D} = {4BF51C21-5A30-423B-82FE-1ED410E5769D}
 		{E53AA5FF-B737-40AA-BD13-387EFA99023D} = {E53AA5FF-B737-40AA-BD13-387EFA99023D}
 		{9CA0FDFB-2172-41FC-B7F1-5CE915EDCB37} = {9CA0FDFB-2172-41FC-B7F1-5CE915EDCB37}
@@ -42,5 +44,4 @@
 		{FE07F272-AE7F-4549-9E9F-EF9B80CB1693} = {FE07F272-AE7F-4549-9E9F-EF9B80CB1693}
 		{A5D9AA24-08ED-48B9-BD65-F0A25E96BFC4} = {A5D9AA24-08ED-48B9-BD65-F0A25E96BFC4}
-		{2BB84911-C1B4-4747-B93D-36AA82CC5031} = {2BB84911-C1B4-4747-B93D-36AA82CC5031}
 	EndProjectSection
 EndProject
@@ -49,6 +50,4 @@
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "sample_debug", "pjsip-apps\build\sample_debug.vcproj", "{A0F1AA62-0F6F-420D-B09A-AC04B6862821}"
 	ProjectSection(ProjectDependencies) = postProject
-		{2BB84911-C1B4-4747-B93D-36AA82CC5031} = {2BB84911-C1B4-4747-B93D-36AA82CC5031}
-		{A5D9AA24-08ED-48B9-BD65-F0A25E96BFC4} = {A5D9AA24-08ED-48B9-BD65-F0A25E96BFC4}
 		{E53AA5FF-B737-40AA-BD13-387EFA99023D} = {E53AA5FF-B737-40AA-BD13-387EFA99023D}
 		{9CA0FDFB-2172-41FC-B7F1-5CE915EDCB37} = {9CA0FDFB-2172-41FC-B7F1-5CE915EDCB37}
@@ -63,4 +62,6 @@
 		{6794B975-4E84-4F49-B2DC-C31F2224E03E} = {6794B975-4E84-4F49-B2DC-C31F2224E03E}
 		{FE07F272-AE7F-4549-9E9F-EF9B80CB1693} = {FE07F272-AE7F-4549-9E9F-EF9B80CB1693}
+		{A5D9AA24-08ED-48B9-BD65-F0A25E96BFC4} = {A5D9AA24-08ED-48B9-BD65-F0A25E96BFC4}
+		{2BB84911-C1B4-4747-B93D-36AA82CC5031} = {2BB84911-C1B4-4747-B93D-36AA82CC5031}
 	EndProjectSection
 EndProject
@@ -102,4 +103,6 @@
 EndProject
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libresample_dll", "third_party\build\resample\libresample_dll.vcproj", "{C48EAAF5-F69E-410B-9CE4-23AB41B00E2A}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libmilenage", "third_party\build\milenage\libmilenage.vcproj", "{4BF51C21-5A30-423B-82FE-1ED410E5769D}"
 EndProject
 Global
@@ -193,4 +196,8 @@
 		{C48EAAF5-F69E-410B-9CE4-23AB41B00E2A}.Release|Win32.ActiveCfg = Release|Win32
 		{C48EAAF5-F69E-410B-9CE4-23AB41B00E2A}.Release|Win32.Build.0 = Release|Win32
+		{4BF51C21-5A30-423B-82FE-1ED410E5769D}.Debug|Win32.ActiveCfg = Debug|Win32
+		{4BF51C21-5A30-423B-82FE-1ED410E5769D}.Debug|Win32.Build.0 = Debug|Win32
+		{4BF51C21-5A30-423B-82FE-1ED410E5769D}.Release|Win32.ActiveCfg = Release|Win32
+		{4BF51C21-5A30-423B-82FE-1ED410E5769D}.Release|Win32.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /pjproject/trunk/pjproject.dsw
===================================================================
--- /pjproject/trunk/pjproject.dsw	(revision 1487)
+++ /pjproject/trunk/pjproject.dsw	(revision 1488)
@@ -28,4 +28,16 @@
 ###############################################################################
 
+Project: "libmilenage"=.\third_party\build\milenage\libmilenage.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
 Project: "libportaudio"=.\THIRD_PARTY\BUILD\PORTAUDIO\libportaudio.dsp - Package Owner=<4>
 
@@ -255,4 +267,7 @@
     Project_Dep_Name libresample
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libmilenage
+    End Project Dependency
 }}}
 
Index: /pjproject/trunk/pjsip-apps/build/wince-evc4/wince_demos.vcw
===================================================================
--- /pjproject/trunk/pjsip-apps/build/wince-evc4/wince_demos.vcw	(revision 1487)
+++ /pjproject/trunk/pjsip-apps/build/wince-evc4/wince_demos.vcw	(revision 1488)
@@ -28,4 +28,16 @@
 ###############################################################################
 
+Project: "libmilenage"="..\..\..\third_party\build\milenage\libmilenage.vcp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
 Project: "libportaudio"="..\..\..\THIRD_PARTY\BUILD\PORTAUDIO\libportaudio.vcp" - Package Owner=<4>
 
@@ -243,4 +255,7 @@
     Project_Dep_Name libspeex
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libmilenage
+    End Project Dependency
 }}}
 
Index: /pjproject/trunk/pjsip/build/pjsip_core.dsp
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 1487)
+++ /pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 1488)
@@ -165,4 +165,8 @@
 # Begin Source File
 
+SOURCE=..\src\pjsip\sip_auth_aka.c
+# End Source File
+# Begin Source File
+
 SOURCE=..\src\pjsip\sip_auth_client.c
 # End Source File
@@ -309,4 +313,8 @@
 # Begin Source File
 
+SOURCE=..\include\pjsip\sip_auth_aka.h
+# End Source File
+# Begin Source File
+
 SOURCE=..\include\pjsip\sip_auth_msg.h
 # End Source File
Index: /pjproject/trunk/pjsip/include/pjsip.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip.h	(revision 1487)
+++ /pjproject/trunk/pjsip/include/pjsip.h	(revision 1488)
@@ -46,4 +46,5 @@
 /* Authentication. */
 #include <pjsip/sip_auth.h>
+#include <pjsip/sip_auth_aka.h>
 
 /* Transaction layer. */
Index: /pjproject/trunk/pjsip/include/pjsip/sip_auth.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_auth.h	(revision 1487)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_auth.h	(revision 1488)
@@ -47,9 +47,12 @@
 
 
-/** Type of data in the credential information. */
+/** Type of data in the credential information in #pjsip_cred_info. */
 typedef enum pjsip_cred_data_type
 {
-    PJSIP_CRED_DATA_PLAIN_PASSWD,   /**< Plain text password.	*/
-    PJSIP_CRED_DATA_DIGEST	    /**< Hashed digest.		*/
+    PJSIP_CRED_DATA_PLAIN_PASSWD=0, /**< Plain text password.		*/
+    PJSIP_CRED_DATA_DIGEST	=1, /**< Hashed digest.			*/
+
+    PJSIP_CRED_DATA_EXT_AKA	=16 /**< Extended AKA info is available */
+
 } pjsip_cred_data_type;
 
@@ -64,4 +67,34 @@
 
 
+/**
+ * Type of callback function to create authentication response.
+ * Application can specify this callback in \a cb field of the credential info
+ * (#pjsip_cred_info) and specifying PJSIP_CRED_DATA_DIGEST_CALLBACK as 
+ * \a data_type. When this function is called, most of the fields in the 
+ * \a auth authentication response will have been filled by the framework. 
+ * Application normally should just need to calculate the response digest 
+ * of the authentication response.
+ *
+ * @param pool	    Pool to allocate memory from if application needs to.
+ * @param chal	    The authentication challenge sent by server in 401
+ *		    or 401 response, in either Proxy-Authenticate or
+ *		    WWW-Authenticate header.
+ * @param cred	    The credential that has been selected by the framework
+ *		    to authenticate against the challenge.
+ * @param auth	    The authentication response which application needs to
+ *		    calculate the response digest.
+ *
+ * @return	    Application may return non-PJ_SUCCESS to abort the
+ *		    authentication process. When this happens, the 
+ *		    framework will return failure to the original function
+ *		    that requested authentication.
+ */
+typedef pj_status_t (*pjsip_cred_cb)(pj_pool_t *pool,
+				     const pjsip_digest_challenge *chal,
+				     const pjsip_cred_info *cred,
+				     const pj_str_t *method,
+				     pjsip_digest_credential *auth);
+
+
 /** 
  * This structure describes credential information. 
@@ -70,5 +103,5 @@
  *
  * Note that since PJSIP 0.7.0.1, it is possible to make a credential that is
- * valid for any realms, by setting the realm to star/asterisk character,
+ * valid for any realms, by setting the realm to star/wildcard character,
  * i.e. realm = pj_str("*");.
  */
@@ -83,4 +116,19 @@
     pj_str_t	data;		/**< The data, which can be a plaintext 
 				     password or a hashed digest.	    */
+
+    /** Extended data */
+    union {
+	/** Digest AKA credential information. Note that when AKA credential
+	 *  is being used, the \a data field of this #pjsip_cred_info is
+	 *  not used, but it still must be initialized to an empty string.
+	 */
+	struct {
+	    pj_str_t	  k;	/**< Permanent key.			*/
+	    pj_str_t	  op;	/**< Operator variant key.		*/
+	    pj_str_t	  amf;	/**< Authentication Management Field	*/
+	    pjsip_cred_cb cb;	/**< Callback to create AKA digest.	*/
+	} aka;
+
+    } ext;
 };
 
@@ -151,4 +199,15 @@
 
 /**
+ * Duplicate a credential info.
+ *
+ * @param pool	    The memory pool.
+ * @param dst	    Destination credential.
+ * @param src	    Source credential.
+ */
+PJ_DECL(void) pjsip_cred_info_dup(pj_pool_t *pool,
+				  pjsip_cred_info *dst,
+				  const pjsip_cred_info *src);
+
+/**
  * Type of function to lookup credential for the specified name.
  *
@@ -350,4 +409,29 @@
 					       pjsip_tx_data *tdata);
 
+/**
+ * Helper function to create MD5 digest out of the specified 
+ * parameters.
+ *
+ * @param result	String to store the response digest. This string
+ *			must have been preallocated by caller with the 
+ *			buffer at least PJSIP_MD5STRLEN (32 bytes) in size.
+ * @param nonce		Optional nonce.
+ * @param nc		Nonce count.
+ * @param cnonce	Optional cnonce.
+ * @param qop		Optional qop.
+ * @param uri		URI.
+ * @param realm		Realm.
+ * @param cred_info	Credential info.
+ * @param method	SIP method.
+ */
+PJ_DECL(void) pjsip_auth_create_digest(pj_str_t *result,
+				       const pj_str_t *nonce,
+				       const pj_str_t *nc,
+				       const pj_str_t *cnonce,
+				       const pj_str_t *qop,
+				       const pj_str_t *uri,
+				       const pj_str_t *realm,
+				       const pjsip_cred_info *cred_info,
+				       const pj_str_t *method);
 
 /**
@@ -355,15 +439,4 @@
  */
 
-/* Internal function defined in sip_auth_client.c */
-void pjsip_auth_create_digest( pj_str_t *result,
-			       const pj_str_t *nonce,
-			       const pj_str_t *nc,
-			       const pj_str_t *cnonce,
-			       const pj_str_t *qop,
-			       const pj_str_t *uri,
-			       const pj_str_t *realm,
-			       const pjsip_cred_info *cred_info,
-			       const pj_str_t *method);
-
 
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_auth_aka.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_auth_aka.h	(revision 1488)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_auth_aka.h	(revision 1488)
@@ -0,0 +1,91 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJSIP_AUTH_SIP_AUTH_AKA_H__
+#define __PJSIP_AUTH_SIP_AUTH_AKA_H__
+
+/**
+ * @file sip_auth_aka.h
+ * @brief SIP Digest AKA Authorization Module.
+ */
+
+#include <pjsip/sip_auth.h>
+
+PJ_BEGIN_DECL
+
+/**
+ * @defgroup PJSIP_AUTH_AKA_API Digest AKA Authentication API's
+ * @ingroup PJSIP_AUTH_API
+ * @brief Digest AKA helper API.
+ * @{
+ *
+ * This module currently exports one function, #pjsip_auth_create_akav1_response(),
+ * which can be registered as the callback function in \a ext.aka.cb field
+ * of #pjsip_cred_info structure, to calculate the MD5-AKAv1 digest
+ * response.
+ */
+
+
+#define PJSIP_AKA_AKLEN		6
+#define PJSIP_AKA_AMFLEN	2
+#define PJSIP_AKA_AUTNLEN	16
+#define PJSIP_AKA_CKLEN		16
+#define PJSIP_AKA_IKLEN		16
+#define PJSIP_AKA_KLEN		16
+#define PJSIP_AKA_OPLEN		16
+#define PJSIP_AKA_RANDLEN	16
+#define PJSIP_AKA_RESLEN	8
+#define PJSIP_AKA_MACLEN	8
+
+/**
+ * This function creates MD5 AKAv1 response for the specified challenge
+ * in \a chal, based on the information in the credential \a cred.
+ * Application may register this function as \a ext.aka.cb field of
+ * #pjsip_cred_info structure to make PJSIP automatically call this
+ * function to calculate the response digest.
+ *
+ * @param pool	    Pool to allocate memory.
+ * @param chal	    The authentication challenge sent by server in 401
+ *		    or 401 response, in either Proxy-Authenticate or
+ *		    WWW-Authenticate header.
+ * @param cred	    The credential that has been selected by the framework
+ *		    to authenticate against the challenge.
+ * @param method    The request method.
+ * @param auth	    The authentication credential where the digest response
+ *		    will be placed to.
+ *
+ * @return	    PJ_SUCCESS if response has been created successfully.
+ */
+PJ_DECL(pj_status_t) pjsip_auth_create_akav1(pj_pool_t *pool,
+					     const pjsip_digest_challenge*chal,
+					     const pjsip_cred_info *cred,
+					     const pj_str_t *method,
+					     pjsip_digest_credential *auth);
+
+
+/**
+ * @}
+ */
+
+
+
+PJ_END_DECL
+
+
+#endif	/* __PJSIP_AUTH_SIP_AUTH_AKA_H__ */
+
Index: /pjproject/trunk/pjsip/include/pjsip/sip_errno.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 1487)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 1488)
@@ -382,4 +382,14 @@
  */
 #define PJSIP_EAUTHSTALECOUNT	(PJSIP_ERRNO_START_PJSIP + 111)	/* 171111 */
+/**
+ * @hideinitializer
+ * Invalid nonce value in the challenge.
+ */
+#define PJSIP_EAUTHINNONCE	(PJSIP_ERRNO_START_PJSIP + 112)	/* 171112 */
+/**
+ * @hideinitializer
+ * Invalid AKA credential.
+ */
+#define PJSIP_EAUTHINAKACRED	(PJSIP_ERRNO_START_PJSIP + 113)	/* 171113 */
 
 
Index: /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 1487)
+++ /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 1488)
@@ -1030,18 +1030,6 @@
 
 
-/**
- * Duplicate credential.
- *
- * @param pool	    The memory pool.
- * @param dst	    Destination credential.
- * @param src	    Source credential.
- *
- * \par Python:
- * Not applicable (for now). Probably we could just assign one credential
- * variable to another, but this has not been tested.
- */
-PJ_DECL(void) pjsip_cred_dup( pj_pool_t *pool,
-			      pjsip_cred_info *dst,
-			      const pjsip_cred_info *src);
+/* The implementation has been moved to sip_auth.h */
+#define pjsip_cred_dup	pjsip_cred_info_dup
 
 
Index: /pjproject/trunk/pjsip/src/pjsip/sip_auth_aka.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_auth_aka.c	(revision 1488)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_auth_aka.c	(revision 1488)
@@ -0,0 +1,121 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pjsip/sip_auth_aka.h>
+#include <pjsip/sip_errno.h>
+#include <pjlib-util/base64.h>
+#include <pjlib-util/md5.h>
+#include <pj/assert.h>
+#include <pj/log.h>
+#include <pj/pool.h>
+#include <pj/string.h>
+
+#include "../../third_party/milenage/milenage.h"
+
+/*
+ * Create MD5-AKA1 digest response.
+ */
+PJ_DEF(pj_status_t) pjsip_auth_create_akav1( pj_pool_t *pool,
+					     const pjsip_digest_challenge*chal,
+					     const pjsip_cred_info *cred,
+					     const pj_str_t *method,
+					     pjsip_digest_credential *auth)
+{
+    pj_str_t nonce_bin;
+    pj_uint8_t *chal_rand, *chal_autn, *chal_mac;
+    pj_uint8_t res[PJSIP_AKA_RESLEN];
+    pj_uint8_t ck[PJSIP_AKA_CKLEN];
+    pj_uint8_t ik[PJSIP_AKA_IKLEN];
+    pj_uint8_t ak[PJSIP_AKA_AKLEN];
+    pj_uint8_t sqn[PJSIP_AKA_AUTNLEN];
+    pj_uint8_t xmac[PJSIP_AKA_MACLEN];
+    pjsip_cred_info aka_cred;
+    int i;
+    pj_status_t status;
+
+    /* Check the algorithm is supported. */
+    if (pj_stricmp2(&chal->algorithm, "md5") == 0) {
+	pjsip_auth_create_digest(&auth->response, &auth->nonce, &auth->nc,
+				 &auth->cnonce, &auth->qop, &auth->uri,
+				 &auth->realm, cred, method);
+	return PJ_SUCCESS;
+
+    } else if (pj_stricmp2(&chal->algorithm, "AKAv1-MD5") != 0) {
+	/* Unsupported algorithm */
+	return PJSIP_EINVALIDALGORITHM;
+    }
+
+    /* Decode nonce */
+    nonce_bin.slen = PJ_BASE64_TO_BASE256_LEN(chal->nonce.slen);
+    nonce_bin.ptr = pj_pool_alloc(pool, nonce_bin.slen + 1);
+    status = pj_base64_decode(&chal->nonce, (pj_uint8_t*)nonce_bin.ptr,
+			      &nonce_bin.slen);
+    if (status != PJ_SUCCESS)
+	return PJSIP_EAUTHINNONCE;
+
+    if (nonce_bin.slen < PJSIP_AKA_RANDLEN + PJSIP_AKA_AUTNLEN + PJSIP_AKA_MACLEN)
+	return PJSIP_EAUTHINNONCE;
+
+    /* Get RAND, AUTN, and MAC */
+    chal_rand = (pj_uint8_t*) (nonce_bin.ptr + 0);
+    chal_autn = (pj_uint8_t*) (nonce_bin.ptr + PJSIP_AKA_RANDLEN);
+    chal_mac =  (pj_uint8_t*) (nonce_bin.ptr + PJSIP_AKA_RANDLEN + PJSIP_AKA_AUTNLEN);
+
+    /* Verify credential */
+    PJ_ASSERT_RETURN(cred->ext.aka.k.slen == PJSIP_AKA_KLEN, PJSIP_EAUTHINAKACRED);
+    PJ_ASSERT_RETURN(cred->ext.aka.op.slen == PJSIP_AKA_OPLEN, PJSIP_EAUTHINAKACRED);
+
+    /* Given key K and random challenge RAND, compute response RES,
+     * confidentiality key CK, integrity key IK and anonymity key AK.
+     */
+    f2345((pj_uint8_t*)cred->ext.aka.k.ptr, 
+	  chal_rand, 
+	  res, ck, ik, ak, 
+          (pj_uint8_t*)cred->ext.aka.op.ptr);
+
+    /* Compute sequence number SQN */
+    for (i=0; i<PJSIP_AKA_AUTNLEN; ++i)
+	sqn[i] = (pj_uint8_t) (chal_autn[i] ^ ak[i]);
+
+    /* Compute XMAC */
+    f1((pj_uint8_t*)cred->ext.aka.k.ptr, chal_rand, sqn,
+       (pj_uint8_t*)cred->ext.aka.amf.ptr, xmac, 
+       (pj_uint8_t*)cred->ext.aka.op.ptr);
+
+    /* Verify MAC in the challenge */
+    if (pj_memcmp(chal_mac, xmac, PJSIP_AKA_MACLEN) != 0) {
+	return PJSIP_EAUTHINNONCE;
+    }
+
+    /* Build a temporary credential info to create MD5 digest, using
+     * "res" as the password. 
+     */
+    pj_memcpy(&aka_cred, cred, sizeof(aka_cred));
+    aka_cred.data_type = PJSIP_CRED_DATA_PLAIN_PASSWD;
+    aka_cred.data.ptr = (char*)res;
+    aka_cred.data.slen = PJSIP_AKA_RESLEN;
+
+    /* Create a response */
+    pjsip_auth_create_digest(&auth->response, &chal->nonce, 
+			     &auth->nc, &auth->cnonce, &auth->qop, &auth->uri,
+			     &chal->realm, &aka_cred, method);
+
+    /* Done */
+    return PJ_SUCCESS;
+}
+
